/*
 * File: StringMedian.c
 *
 * Author: M. I. Karavelas
 * Class:  EM101 / Fall Semester 2008
 */

#include "StringMedian.h"


/*
 * Function: StringMedian
 * Usage: str = StringMedian(string_array, n);
 * -------------------------------------------
 * Returns the median string of the array string_array containing n
 * strings.
 *
 * The algorithm employed for computing the median is a very simple
 * quadratic time algorithm (we assume that all elements in the array
 * are distinct): for each element in the array compute the
 * number of elements before and after it in the sorted list of
 * elements. For odd-sized string sets, if the number of elements
 * before an element equals the number of elements after it, return
 * this element as the median element.
 * For even-sized string sets, if the number of elements before an
 * elements is exactly one less than the number of elements after it,
 * return this element as the median element.
 */

string StringMedian(string str_array[], int n)
{
  int i, j, nbefore, nafter, comp;
  int n_mod_2 = n % 2;
  string str;

  for (i = 0; i != n; i++) {
    nbefore = nafter = 0;
    /* count number of string before and after str_array[i] */
    for (j = 0; j != n; j++) {
      comp = StringCompare(str_array[j], str_array[i]);
      if ( comp < 0 ) {
	nbefore++;
      } else if ( comp > 0 ) {
	nafter++;
      }
    }
    /* for odd sized arrays, the median has the property that there
       is an equal number of elements before and after

       for even sized arrays, the median has one less element before
       that after (in the sorted list of elements

       we can encapsulate both cases in the following expression
    */
    if ( nbefore + 1 == nafter + n_mod_2 ) { break; }
  }

  return str_array[i];
}
