/*
 * File: median.c
 * --------------
 *
 * This program asks for a file, reads words from this file and then
 * returns the number of words read and the median word among the
 * words reads.
 *
 * Author: M. I. Karavelas
 * Class:  EM101 / Fall Semester 2008
 * Homework #: 5
 */

#include <stdio.h>
#include "genlib.h"
#include "simpio.h"
#include "FileReader.h"
#include "StringMedian.h"


/* Maximum number of words that our program can read/handle */
#define MaxWords 2000


/*
 * Function: ReadWords
 * Usage: n = ReadWords(myfile, words);
 * ------------------------------------
 * Opens file with name filename, reads the word in it, placing them
 * into the array words and returns the number of words read.
 * This function is visible only within the scope of this file.
 */

static int ReadWords(string filename, string words[])
{
  int n = 0;

  if ( !OpenFile(filename) ) {
    Error("Cannot open file name: %s\n", filename);
  }

  while ( !AtEndOfFile() ) {
    if ( n >= MaxWords ) {
      Error("Too many words in file \"%s\".\n", filename);
    }
    words[n++] = GetNextWord();
  }

  return n;
}



/* main program */

main()
{
  string filename;
  string words[MaxWords];
  int nwords;

  /* read file name */
  printf("Enter file containing words: ");
  filename = GetLine();

  /* read words from file */
  nwords = ReadWords(filename, words);

  /* print number of words read */
  printf("Number of words: %d\n", nwords);

  /* compute and print median of strings */
  printf("The median word is: \"%s\"\n", StringMedian(words, nwords));
}
